/*

	csgo-clantag-linux -- unrestricted clan tag changer for 64-bit CS:GO on Linux
	Read more at https://aixxe.net/2016/10/custom-clantag-csgo/

	Copyright (C) 2017, aixxe. (www.aixxe.net)
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with csgo-clantag-linux. If not, see <http://www.gnu.org/licenses/>.

*/

#include <link.h>
#include <memory>

#include "sdk.h"
#include "findpattern.h"
#include "vmthook/vmthook.h"

/* clan tag to use in-game */
#define USER_CLANTAG "[VALV\xE1\xB4\xB1]"

/* signature to SendClanTag function */
#define SENDCLANTAG_SIGNATURE "\x55\x48\x89\xE5\x48\x89\x5D\xE8\x4C\x89\x65\xF0\x49\x89\xFC\xBF\x48\x00\x00\x00\x4C\x89\x6D\xF8\x48\x83\xEC\x20\x49"
#define SENDCLANTAG_MASK "xxxxxxxxxxxxxxxxxxxxxxxxxxxxx"

/* game interface pointers */
IBaseClientDLL* clientdll = nullptr;

/* function forward declaration */
SendClanTagFn SendClanTag = nullptr;

/* virtual table hooks */
std::unique_ptr<VMTHook> clientmode_hook;

/* replacement CreateMove function */
bool hkCreateMove(void* thisptr, float flInputSampleTime, CUserCmd* cmd) {
	if (cmd && cmd->command_number)
		SendClanTag(USER_CLANTAG, "");

	return clientmode_hook->GetOriginalFunction<CreateMoveFn>(25)(thisptr, flInputSampleTime, cmd);
}

/* called when the library is loading */
int __attribute__((constructor)) clantag_init() {
	/* obtain pointers to game interface classes */
	clientdll = GetInterface<IBaseClientDLL>("./csgo/bin/linux64/client_client.so", CLIENT_DLL_INTERFACE_VERSION);

	/* get the HudProcessInput function address from CHLClient */
	uintptr_t hudprocessinput = reinterpret_cast<uintptr_t>(GetVirtualTable(clientdll)[10]);

	/* get the GetClientMode function address from 11 bytes in */
	GetClientModeFn GetClientMode = (GetClientModeFn)GetAbsoluteAddress(hudprocessinput + 11, 1, 5);

	/* get engine_client.so base address */
	uintptr_t engine_client = 0;

	dl_iterate_phdr([] (struct dl_phdr_info* info, size_t size, void* data) {
		if (strcasestr(info->dlpi_name, "engine_client.so")) {
			*reinterpret_cast<uintptr_t*>(data) = info->dlpi_addr + info->dlpi_phdr[0].p_vaddr;
			return 1;
		}

		return 0;
	}, &engine_client);

	/* find SendClanTag function in engine_client.so */
	uintptr_t func_address = FindPattern(engine_client, 0xFFFFFFFFF, (unsigned char*)SENDCLANTAG_SIGNATURE, SENDCLANTAG_MASK);

	if (!func_address)
		return 1;

	/* cast to appropriate type */
	SendClanTag = reinterpret_cast<SendClanTagFn>(func_address);

	/* hook IClientMode::CreateMove */
	clientmode_hook = std::make_unique<VMTHook>(GetClientMode());
	clientmode_hook->HookFunction(reinterpret_cast<void*>(hkCreateMove), 25);

	return 0;
};